
Public Class Form1
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        lstNaughty.AllowDrop = True
        lstNice.AllowDrop = True

        lstNaughty.Items.Add(New Person("Ann", "Archer"))
        lstNaughty.Items.Add(New Person("Ban", "Baker"))
        lstNaughty.Items.Add(New Person("Cindy", "Cant"))
        lstNice.Items.Add(New Person("Dan", "Dent"))
        lstNice.Items.Add(New Person("Edna", "Everly"))
        lstNice.Items.Add(New Person("Fred", "Franklin"))
    End Sub

    ' Start a drag.
    Private Sub ListBox_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles lstNaughty.MouseDown, lstNice.MouseDown
        Dim lst As ListBox = DirectCast(sender, ListBox)

        If e.Button = Windows.Forms.MouseButtons.Right Then
            Dim index As Integer = lst.IndexFromPoint(e.X, e.Y)
            If index <> ListBox.NoMatches Then
                Dim per As Person = lst.Items(index)
                Dim drop_effect As DragDropEffects = _
                    lst.DoDragDrop( _
                        per, _
                        DragDropEffects.Move Or DragDropEffects.Copy)

                ' If it was moved, remove the item from this list.
                If drop_effect = DragDropEffects.Move Then
                    lst.Items.Remove(per)
                End If
            End If
        End If
    End Sub

    ' Display the appropriate cursor.
    Private Sub ListBox_DragOver(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lstNaughty.DragOver, lstNice.DragOver
        Const KEY_CTRL As Integer = 8

        If Not (e.Data.GetDataPresent("howto_net_drag_drop_listbox_objects.Person")) Then
            e.Effect = DragDropEffects.None
        ElseIf (e.KeyState And KEY_CTRL) And _
        (e.AllowedEffect And DragDropEffects.Copy) = DragDropEffects.Copy Then
            ' Copy.
            e.Effect = DragDropEffects.Copy
        ElseIf (e.AllowedEffect And DragDropEffects.Move) = DragDropEffects.Move Then
            ' Move.
            e.Effect = DragDropEffects.Move
        End If
    End Sub

    ' Drop the entry in the list.
    Private Sub ListBox_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lstNaughty.DragDrop, lstNice.DragDrop
        If e.Data.GetDataPresent("howto_net_drag_drop_listbox_objects.Person") Then
            If (e.Effect = DragDropEffects.Copy) Or _
            (e.Effect = DragDropEffects.Move) Then
                Dim lst As ListBox = DirectCast(sender, ListBox)
                Dim item As Person = DirectCast( _
                    e.Data.GetData("howto_net_drag_drop_listbox_objects.Person"), _
                    Person)
                item = New Person(item.FirstName, item.LastName)
                Dim pt As Point = lst.PointToClient(New Point(e.X, e.Y))
                Dim index As Integer = lst.IndexFromPoint(pt.X, pt.Y)
                If index = ListBox.NoMatches Then
                    lst.Items.Add(item)
                Else
                    lst.Items.Insert(index, item)
                End If
            End If
        End If
    End Sub
End Class
